/*
------------------------ Это материнский класс всех сцен ---------------------------
*/
class RootState {
    constructor(){}
    ///Главное инициирование (создаются объекты для всех сцен)
    mainInit(){
        this.GUI = new GUI(game);
        this.windowsIsOpen = [];
        if(SOUND_MUTE == "NO"){
            game.sound.mute = false;
        }else if(SOUND_MUTE == "YES")
            game.sound.mute = true;
    }
    ///Главное обновления (сюда добавляются обновления для всех сцен)
    mainUpdate(){
        ////Динамеские обновления
        this.GUI.update();
        
    }
    mainCreate(){
        this.game.time.advancedTiming = true;
        this.game.renderer.renderSession.roundPixels = true;
        //game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
        
    }
    mainRender(){
        if(DEBUGMODE){
            let calor = "#00ff00"
            if(KEEPER.serverStatus == 'Online')
                calor = '#7CFC00';
            else
                calor = '#FF4500';
            this.game.debug.text('FPS: '+this.game.time.fps || '--', 2, this.game.height - 10, "#00ff00");  
            this.game.debug.text('State: '+game.state.current, 2, this.game.height - 20, "#00ff00"); 
            this.game.debug.text('ServerStatus: '+KEEPER.serverStatus, this.game.width - 170,this.game.height -  10, calor); 
        }
        
        
        
    }
    createМanualWindow(){
     var that = this;
        let ui = that.GUI.addUI(this.game.width/2 - 500,this.game.height/2 - 300,1000,600,null,null,10);
        //let ui = mainUI.addUI(10,true,mainUI.width/2 - 500,mainUI.height/2 - 300,1000,600,15);
        //mainUI.addCastomSizeBackground(0,1024,768,'background6',1,false);
        ui.addFullWindowRect(0,0,0,this.game.width,this.game.height,true,0x000000,0.5,function(){
            ui.delete();
        });
        ui.addBackground(0,'ui_1000_600',1,true);  
        ui.addButton(1,true,ui.width -30,30,60,60,'button_close',function(){
            ui.delete();
        },'onclick','onover',BUTTONVALUE,1);
        let relesButton = ui.addButtonWithText(1,true,100,30,96,32,'button_empty',function(){
           currentPage = 'rules';
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text25',LANGUAGE),ASSETS.textStyles['button'],1);
        let deckButton = ui.addButtonWithText(1,true,200,30,96,32,'button_empty',function(){
           currentPage = 'deck';
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text148',LANGUAGE),ASSETS.textStyles['button'],1);
        let termsButton = ui.addButtonWithText(1,true,300,30,96,32,'button_empty',function(){
           currentPage = 'terms';
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text90',LANGUAGE),ASSETS.textStyles['button'],1);
        let hintsButton = ui.addButtonWithText(1,true,400,30,96,32,'button_empty',function(){
           currentPage = 'hints';
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text104',LANGUAGE),ASSETS.textStyles['button'],1);
        let aboutButton = ui.addButtonWithText(1,true,500,30,96,32,'button_empty',function(){
           currentPage = 'about';
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text122',LANGUAGE),ASSETS.textStyles['button'],1);
        
        /*
        let classButton = ui.addButtonWithText(1,true,ui.width*0.3,ui.height*0.1,96,32,'button_empty',function(){
            currentPage = 'class';
        },'onclick','onover',BUTTONVALUE,ASSETS.getText('text66',LANGUAGE),ASSETS.textStyles['button'],1);
        */
        let wordStylesForTerms = [];
        wordStylesForTerms.push({word:'ELF',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'races',frame:0}); 
        wordStylesForTerms.push({word:'HUMAN',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'races',frame:1}); 
        wordStylesForTerms.push({word:'ORC',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'races',frame:2}); 
        wordStylesForTerms.push({word:'DEMON',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'races',frame:3}); 
        wordStylesForTerms.push({word:'UNDEAD',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'races',frame:4}); 
        wordStylesForTerms.push({word:'ARCHER',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'classes',frame:0}); 
        //wordStylesForTerms.push({word:'PRIEST',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'classes',frame:0}); 
        wordStylesForTerms.push({word:'WARRIOR',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'classes',frame:1}); 
        wordStylesForTerms.push({word:'MAGE',style:ASSETS.textStyles['commonW'],isWord:false,imageKey:'classes',frame:2}); 
        //wordStylesForTerms.push({word:'ROGUE',style:ASSETS.textStyles['common'],isWord:false,imageKey:'classes',frame:0}); 
        
        wordStylesForTerms.push({word:'Очки',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0}); 
        wordStylesForTerms.push({word:'Раса',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Класс',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Оппонент',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Враги',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Все',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Ворует',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Раскрывает',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Скрывает',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Отключает',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Ничья',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        
        wordStylesForTerms.push({word:'Points',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0}); 
        wordStylesForTerms.push({word:'Race',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Class',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Opponent',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Enemies',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'All',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Steals',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Hides',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Reveals',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Disables',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        wordStylesForTerms.push({word:'Draw',style:ASSETS.textStyles['commonGoldBold'],isWord:true,imageKey:null,frame:0});
        
        let childUI = ui.addUI(1,true,50,50,900,500,15);
        //childUI.addBackground(0,'ui_4',1,true);
        
        function drawRules(){
             let name = childUI.addBitMapText(1,true,childUI.width*0.5,15,ASSETS.getText('text25',LANGUAGE),'font_1',30,1,false);
            name.tint = 0xFFDAB9;
            let text = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.5,ASSETS.getText('text26',LANGUAGE),ASSETS.textStyles['commonW'],1,false);
            //text.wordWrapWidth = childUI.width*0.9;
            console.log(text)
 
        }
        function drawTerms(){
            let name = childUI.addBitMapText(1,true,childUI.width*0.5,15,ASSETS.getText('text90',LANGUAGE),'font_1',30,1,false);
            name.tint = 0xFFDAB9;
        
            let text = childUI.addUIWithTextAndImage(2,true,childUI.width*0.5,childUI.height*0.55,childUI.width*0.95,'left',ASSETS.getText('text92',LANGUAGE),wordStylesForTerms,ASSETS.textStyles['commonW'],28,1,false);
            console.log(text)
            //let text = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.5,ASSETS.getText('text26',LANGUAGE),ASSETS.textStyles['common'],1,false);
        }
        function drawHints(){
            let name = childUI.addBitMapText(1,true,childUI.width*0.5,15,ASSETS.getText('text104',LANGUAGE),'font_1',30,1,false);
            name.tint = 0xFFDAB9;
            
            let count = 1;
            let str = '';
            for(let i = 0; i < 7; i++){
                
                str += '- '+ASSETS.getText('hint'+count,LANGUAGE);
                if(i !== 7)
                    str += '\n';
                count++;
            }
            let text = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.55,str,ASSETS.textStyles['commonW'],1,false);
            text.maxLines = 1000;
            console.log(text.height)
            console.log(text)
            //let text = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.5,ASSETS.getText('text26',LANGUAGE),ASSETS.textStyles['common'],1,false);
        }
        function drawRace(){
            let description = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.05,'Расы\nВ зависимости от расы карты получают различные бонусы',ASSETS.textStyles['commonBigString'],1,false);
            //description.anchor.setTo(0.5,0.5);
            for(let i = 0 ; i < 6 ; i ++){
                let raceInfo,raceKey, raceName;
                let raceActions = [];
                if(i == 0){
                    let creatureInfo = ATLAS.getCreatureInfoById(1);
                    raceActions.push(creatureInfo.actionsType[0]);
                    raceKey = 'all_races';
                    raceName = 'Все Расы';
                }else{
                    raceInfo = ATLAS.getRaceInfoById(i);
                    raceActions = raceInfo.actionsType;
                    raceKey = raceInfo.imageKey;
                    raceName = raceInfo.name;
                }
                let raceImage = childUI.addImage(2,true,childUI.width*0.3,childUI.height*0.2 + 70*i ,64,64,raceKey,1,true);
                let string ='';
                for(let j in raceActions){
                    let action = ATLAS.getActionTypesById(raceActions[j])
                    string += action.description;
                }
                let text =childUI.addText(1,false,raceImage.x + 100,raceImage.y,raceName+': '+string,ASSETS.textStyles['commonBigString'],1,false);
                text.x = text.x - (50 - text.width/2);
                //text.anchor.setTo(0.0,0.5);

            }
        }
        function drawClass(){
            let description = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.05,'Классы\nВ зависимости от класса, карты получают различные бонусы',ASSETS.textStyles['commonBigString'],1,false);
            //description.anchor.setTo(0.5,0.5);
            for(let i = 0 ; i < 6 ; i ++){
                let classInfo,classKey, className;
                let classActions = [];
                if(i == 0){
                    let creatureInfo = ATLAS.getCreatureInfoById(1);
                    classActions.push(creatureInfo.actionsType[1]);
                    classKey = 'all_classes';
                    className = 'Все Классы';
                }else{
                    classInfo = ATLAS.getClassInfoById(i);
                    classActions = classInfo.actionsType;
                    classKey = classInfo.imageKey;
                    className = classInfo.name;
                }
                let classImage = childUI.addImage(2,true,childUI.width*0.3,childUI.height*0.2 + 70*i ,64,64,classKey,1,true);
                let string ='';
                for(let j in classActions){
                    let action = ATLAS.getActionTypesById(classActions[j])
                    string += action.description;
                }
                let text =childUI.addText(1,false,classImage.x + 100,classImage.y,className+': '+string,ASSETS.textStyles['commonBigString'],1,false);
                text.x = text.x - (50 - text.width/2);
                //text.anchor.setTo(0.0,0.5);

            }
        }
        function drawAbout(){
            let name = childUI.addBitMapText(1,true,childUI.width*0.5,15,ASSETS.getText('text122',LANGUAGE),'font_1',30,1,false);
            name.tint = 0xFFDAB9;
        
            let text = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.5,ASSETS.getText('text127',LANGUAGE)+'\n'+ASSETS.getText('text1',LANGUAGE)+clientVersion,ASSETS.textStyles['commonW'],1,false);
            //text.wordWrapWidth = childUI.width*0.9;
            console.log(text)
 
        }
        function drawDeck(){
            let name = childUI.addBitMapText(1,true,childUI.width*0.5,15,ASSETS.getText('text148',LANGUAGE),'font_1',30,1,false);
            name.tint = 0xFFDAB9;
            let cardCount = 0;
            let classCount = 0;
            let raceCount = 0;
            let cardW = 265*0.35;
            let cardH = 415*0.35;
            let distance = 5;
            for(let x = 0;x<5;x++){
                
                for(let y = 0;y<3;y++){
                    let cardType = ATLAS.creatureTypes[cardCount];
                    console.log(cardType)
                    let card = childUI.addImage(2,true,childUI.width*0.5 - 200 +(x*cardW)+x*distance,childUI.height*0.5 - 90  +(y*cardH)+y*distance,cardW,cardH,cardType.imageKey,1,false);
                    card.frame = cardCount;
                   
                        
                    
                    if((y == 0)){
                        let race = ATLAS.getRaceInfoById(cardType.raceId);
                        let raceImage = childUI.addImage(2,false,card.x,card.y - 100,50,50,race.imageKey,1,true);
                        raceImage.frame = raceCount;
                        childUI.addTitle(200,'right','bot',ASSETS.textStyles['title'],raceImage,function(){
                            return ASSETS.getText(race.nameText,LANGUAGE);
                        });
                        raceCount++;
                        
                        
                    }
                    if((x == 0)){
                        let cls = ATLAS.getClassInfoById(cardType.classId);
                        let classImage = childUI.addImage(2,false,card.x -80,card.y,50,50,cls.imageKey,1,true);
                        classImage.frame = classCount;
                        childUI.addTitle(200,'right','bot',ASSETS.textStyles['title'],classImage,function(){
                            return ASSETS.getText(cls.nameText,LANGUAGE);
                        });
                        classCount++;
                        
                    }
                    cardCount++;
                }
            }
        
            
            //let text = childUI.addText(1,true,childUI.width*0.5,childUI.height*0.5,ASSETS.getText('text26',LANGUAGE),ASSETS.textStyles['common'],1,false);
        }
   
        
        
        let currentPage = 'rules'
        let lastPage = null;
        ui.addUpdate(function(){
            if(lastPage !== currentPage){
                ///Чистим
                childUI.clear();
                switch(currentPage){
                    case 'race':
                        //drawRace();
                        break;
                    case 'class':
                        //drawClass();
                        break; 
                    case 'rules':
                        drawRules();
                        break;
                    case 'terms':
                        drawTerms();
                        break;
                    case 'hints':
                        drawHints();
                        break;
                    case 'about':
                        drawAbout();
                        break;
                    case 'deck':
                        drawDeck();
                        break;
                        
                        
                        
                }
                
                
                
                lastPage = currentPage;
            }
            if(currentPage == 'terms'){
                termsButton.button.tint = 0x696969;
                termsButton.text.tint = 0x696969; 
            }else{
                termsButton.button.tint = 0xFFFFFF;
                termsButton.text.tint = 0xFFFFFF;
            }
            /*
            if(currentPage == 'class'){
                classButton.button.tint = 0x696969;
                classButton.text.tint = 0x696969; 
            }else{
                classButton.button.tint = 0xFFFFFF;
                classButton.text.tint = 0xFFFFFF;
            }
            */
            if(currentPage == 'rules'){
                relesButton.button.tint = 0x696969; 
                relesButton.text.tint = 0x696969;
            }else{
                relesButton.button.tint = 0xFFFFFF;
                relesButton.text.tint = 0xFFFFFF;
            }
            if(currentPage == 'hints'){
                hintsButton.button.tint = 0x696969; 
                hintsButton.text.tint = 0x696969;
            }else{
                hintsButton.button.tint = 0xFFFFFF;
                hintsButton.text.tint = 0xFFFFFF;
            }
            if(currentPage == 'about'){
                aboutButton.button.tint = 0x696969; 
                aboutButton.text.tint = 0x696969;
            }else{
                aboutButton.button.tint = 0xFFFFFF;
                aboutButton.text.tint = 0xFFFFFF;
            }
            if(currentPage == 'deck'){
                deckButton.button.tint = 0x696969; 
                deckButton.text.tint = 0x696969;
            }else{
                deckButton.button.tint = 0xFFFFFF;
                deckButton.text.tint = 0xFFFFFF;
            }
        });
        
    }
    addQuestButton(mainUI,x,y,usable,button){
        var that = this;
        let window = null;
        ///Добавляем кнопку квестов
        let buttonQuest = mainUI.addButton(2,true,x,y,50,50,'button_quest',function(){
           window = createQuestWindow();
        },'onclick','onover',BUTTONVALUE,1);
        if(button){
            button.events.onInputDown.add(function(){
                window = createQuestWindow();
            }, that);
        }
        
        ///Анимация выполненного квеста
        let compliteQuest = mainUI.addImage(2,false,buttonQuest.x,buttonQuest.y,32,32,'quest',1,false);
        compliteQuest.animations.add('blink');
        compliteQuest.animations.play('blink', 10, true);
        
        function addRewards(mainUI,rewardsArray,startX,startY,isFail){
            let y = startY;
            let bordW = 40;
            let imgW = 32;
            let dist = 5;
            let tesxtSize = 18;
            let isNotCompleteImage;
            for(let i = 0; i < rewardsArray.length;i++){
                let x = startX - ((rewardsArray.length*(bordW + dist))/2 - bordW/2 - dist/2) + (i*(bordW+dist))
                switch(rewardsArray[i].numb){
                        case 1:
                            ///Опыт
                            let expBorder = mainUI.addImage(1,true,x,y,bordW,bordW,'qwestBorder',0,false);
                            let expIcon = mainUI.addImage(2,true,x,y,imgW,imgW,'battleCount',0,true);
                            expIcon.frame = 5;
                            let expCount = mainUI.addBitMapText(3,true,x+bordW/4,y+bordW/4,rewardsArray[i].args[0],'font_1',tesxtSize,0,false);
                            expCount.tint = 0xFF4500;
                            mainUI.addTitleTextWithImages(300,'right','top','center',ASSETS.wordStyles,ASSETS.textStyles['title'],expIcon,function(){
                                return ASSETS.getText('text116',LANGUAGE);
                            });
                            
                            break;
                        case 2:
                            ///Случайная фишка
                            let randomArtBorder = mainUI.addImage(1,true,x,y,bordW,bordW,'qwestBorder',0,false);
                            let randomArtIcon = mainUI.addImage(2,true,x,y,imgW,imgW,'art_random_'+rewardsArray[i].args[1],0,true);
                            let randomArtCount = mainUI.addBitMapText(3,true,x+bordW/4,y+bordW/4,rewardsArray[i].args[0],'font_1',tesxtSize,0,false);
                            randomArtCount.tint = 0xFF4500;
                            mainUI.addTitleTextWithImages(300,'right','top','center',ASSETS.wordStyles,ASSETS.textStyles['title'],randomArtIcon,function(){
                                return ASSETS.getText('text117',LANGUAGE);
                            });
                        
                          
                            break;
                        case 3:
                            ///Определенная фишка
                            let specialArtData = ATLAS.getArtifactInfoById(rewardsArray[i].args[0]);
                            let specialArtBorder = mainUI.addImage(1,true,x,y,bordW,bordW,'qwestBorder',0,false);
                            let specialArtIcon = mainUI.addImage(2,true,x,y,imgW,imgW,specialArtData.imageKey,0,true);
                        
                            that.addTitleForArtifacts(mainUI,specialArtIcon,function(){
                                return specialArtData.id;
                            });
                            
                            break;
                        case 4:
                            ///Монеты
                            let coinsCount =  rewardsArray[i].args[0];
                            let coinsBorder = mainUI.addImage(1,true,x,y,bordW,bordW,'qwestBorder',0,false);
                            let coinsIcon = mainUI.addImage(2,true,x,y,imgW,imgW,'coins',0,true);
                            let coinsCountText = mainUI.addBitMapText(3,true,x+bordW/4,y+bordW/4,coinsCount,'font_1',tesxtSize,0,false);
                            coinsCountText.tint = 0xFF4500;
                            mainUI.addTitleTextWithImages(300,'right','top','center',ASSETS.wordStyles,ASSETS.textStyles['title'],coinsIcon,function(){
                                return ASSETS.getText('text135',LANGUAGE);
                            });
                            break;
                            
                    }
                    isNotCompleteImage = mainUI.addImage(4,true,x,y,imgW*2,imgW*2,'qwestComlpite',0,false);
                    isNotCompleteImage.frame = 1;
                    isNotCompleteImage.visible = false;
                    if(isFail)
                        isNotCompleteImage.visible = true;
            
            }
        }
        
        function createQuestWindow(){
            if( KEEPER.user.quests.current.status == 'empty') {
                return addChoiseUI();
            }else{
                return addCurrentQuestUI();
            }
        }
         
            
            
        function addChoiseUI(){
            let firstUi = that.GUI.addUI(that.game.width/2 - 500,that.game.height/2 - 300,1000,600,null,null,10);
            firstUi.addFullWindowRect(0,0,0,that.game.width,that.game.height,true,0x000000,0.5,function(){
                firstUi.delete();
            });
            firstUi.addBackground(1,'ui_600_400',0,true);
            
            let ui = firstUi.addUI(1,true,firstUi.width/2 - 300,firstUi.height/2 - 200,600,400,15);
            ui.addButton(1,true,ui.width -30,30,60,60,'button_close',function(){
                firstUi.delete();
            },'onclick','onover',BUTTONVALUE,0);
            
            let uiName = ui.addBitMapText(1,true,ui.width*0.5,-30,ASSETS.getText('text118',LANGUAGE),'font_1',30,0,false);
            uiName.tint = 0xFFDAB9;
            //let choiseText = ui.addText(1,true,ui.width*0.5,70,ASSETS.getText('text111',LANGUAGE),ASSETS.textStyles['common'],0,false);
            let choiseText = ui.addBitMapText(1,true,ui.width*0.5,30,ASSETS.getText('text111',LANGUAGE),'font_1',20,0,false);
            choiseText.tint = 0xFFD700;
            
            
            ///Квест 1
            
            let quest = ATLAS.getQuestById(KEEPER.user.quests.current.offers.low)
            let str = KEEPER.getTextByCurrentLanguage(quest.name);
            let text = ui.addUIWithBitmapTextAndImage(1,true,ui.width*0.3,ui.height*0.35,ui.width*0.35,'center',str,ASSETS.wordStyles,ASSETS.textStyles['commonWhite'],25,0,false);
            
            let rewordText = ui.addBitMapText(1,true,ui.width*0.3,ui.height*0.5,ASSETS.getText('text113',LANGUAGE)+':','font_1',16,0,false);
            rewordText.tint = 0xFFD700;
            addRewards(ui,quest.rewardsArray,ui.width*0.3,ui.height*0.6,false);
            //////////////////////////////////////////////////////////
            ///Квест 2
            quest = ATLAS.getQuestById(KEEPER.user.quests.current.offers.high)
            str = KEEPER.getTextByCurrentLanguage(quest.name);
            text = ui.addUIWithBitmapTextAndImage(1,true,ui.width*0.7,ui.height*0.35,ui.width*0.35,'center',str,ASSETS.wordStyles,ASSETS.textStyles['commonWhite'],25,0,false);
            
            rewordText = ui.addBitMapText(1,true,ui.width*0.7,ui.height*0.5,ASSETS.getText('text113',LANGUAGE)+':','font_1',16,0,false);
            rewordText.tint = 0xFFD700;
            addRewards(ui,quest.rewardsArray,ui.width*0.7,ui.height*0.6,false);
          
            //////////////////////////////////////////////////////////
            
            if(usable){
                let button1 = ui.addButtonWithText(1,true,ui.width*0.3,ui.height*0.85,190,40,'button_empty',function(){
                    ///Если выполнено последнее задание
                    HANDLER.choiseQuest(KEEPER.user.quests.current.offers.low);
                },'onclick','onover',BUTTONVALUE,ASSETS.getText('text114',LANGUAGE),ASSETS.textStyles['button'],0);

                let button2 = ui.addButtonWithText(1,true,ui.width*0.7,ui.height*0.85,190,40,'button_empty',function(){
                    ///Если выполнено последнее задание
                    HANDLER.choiseQuest(KEEPER.user.quests.current.offers.high);
                },'onclick','onover',BUTTONVALUE,ASSETS.getText('text114',LANGUAGE),ASSETS.textStyles['button'],0);
            }else{
                let errorText = ui.addText(1,true,ui.width*0.5,ui.height*0.85,ASSETS.getText('text115',LANGUAGE),ASSETS.textStyles['common'],0,false);
            }
            
            
            
            
            
            firstUi.addTween(['texts','images'],{ alpha: 1 },500);
            
            
            
            
            return firstUi;
        }
            
        function addCurrentQuestUI(){
            let isFail = false;
            if(KEEPER.user.quests.current.status == 'fail')
                isFail = true;
            let firstUi = that.GUI.addUI(that.game.width/2 - 500,that.game.height/2 - 300,1000,600,null,null,10);
            firstUi.addFullWindowRect(0,0,0,that.game.width,that.game.height,true,0x000000,0.5,function(){
                firstUi.delete();
            });
            firstUi.addBackground(1,'ui_600_400',0,true);
            let ui = firstUi.addUI(1,true,firstUi.width/2 - 300,firstUi.height/2 - 200,600,400,15);
            ui.addButton(1,true,ui.width -30,30,60,60,'button_close',function(){
                firstUi.delete();
            },'onclick','onover',BUTTONVALUE,0);
            
            let uiName = ui.addBitMapText(1,true,ui.width*0.5,-30,ASSETS.getText('text118',LANGUAGE),'font_1',30,0,false);
            uiName.tint = 0xFFDAB9;


            //let doneText = ui.addText(1,true,ui.width*0.5,50,ASSETS.getText('text86',LANGUAGE),ASSETS.textStyles['commonGreen'],0,false);
            let doneText = ui.addBitMapText(1,true,ui.width*0.5,30,ASSETS.getText('text86',LANGUAGE),'font_1',20,0,false);
            let currentQuestIconBorder = ui.addImage(1,true,ui.width*0.5,100,80,80,'qwestBorder',0,false);
            let currentQuestIcon = ui.addImage(1,true,ui.width*0.5,100,64,64,'qwests',0,false);
            currentQuestIcon.frame = 2;
            let currentQuestComlpiteIcon = ui.addImage(1,true,ui.width*0.5,100,80,80,'qwestComlpite',0,false);
            currentQuestComlpiteIcon.visible = false;

            //let task = ATLAS.getQuestById(KEEPER.user.tasks.current.id)
            let quest = ATLAS.getQuestById(KEEPER.user.quests.current.id);
            ///Если такого квеста не существует
            if(!quest){
                KEEPER.trowERROR('Current Quest [id:'+KEEPER.user.quests.current.id+'] not Found!!!');
                return;
            }
       
            let str = KEEPER.getTextByCurrentLanguage(quest.name);

            //let text = ui.addText(1,true,ui.width*0.5,ui.height*0.5,str+'['+KEEPER.user.quests.current.id+']',ASSETS.textStyles['commonString'],0,false);
            
            
            let text = ui.addUIWithBitmapTextAndImage(1,true,ui.width*0.5,ui.height*0.4,ui.width*0.9,'center',str,ASSETS.wordStyles,ASSETS.textStyles['commonWhite'],25,0,false);
            
            let rewordText = ui.addBitMapText(1,true,ui.width*0.5,ui.height*0.5,ASSETS.getText('text113',LANGUAGE)+':','font_1',16,0,false);
            rewordText.tint = 0xFFD700;
         
            addRewards(ui,quest.rewardsArray,ui.width*0.5,ui.height*0.65,isFail);
            
            function onChange(){

            }
            
            let button = ui.addButtonWithText(1,true,ui.width*0.5,ui.height*0.9,190,40,'button_empty',function(){
                ///Если выполнено последнее задание
                if((KEEPER.user.quests.current.status == 'complite') || (KEEPER.user.quests.current.status == 'fail')){
                    HANDLER.getQuestReword();
                }
            },'onclick','onover',BUTTONVALUE,ASSETS.getText('text104',LANGUAGE),ASSETS.textStyles['button'],0);
            //let timeText = ui.addText(1,true,ui.width*0.5,ui.height*0.8,KEEPER.user.quests.leftTimeToChange,ASSETS.textStyles['commonString'],0,false);
            let attemptsText = ui.addBitMapText(1,true,ui.width*0.5,ui.height*0.8,'','font_1',16,0,false);
            //let timeText = ui.addBitMapText(1,true,ui.width*0.5,ui.height*0.85,'','font_1',30,0,false);
            //timeText.tint = 0xFFD700;
            function redrawQuestInfo(quest){
                text.setText(KEEPER.getTextByCurrentLanguage(quest.name));
                rewStr = '';
                for(let i in quest.rewardsArray){
                    switch(quest.rewardsArray[i].numb){
                        case 1:
                            rewStr += '+'+quest.rewardsArray[i].args[0]+' EXPERIENCE ';
                            break;
                        case 2:
                            //rewStr += quest.rewardsArray[i].args[0]+' QUALITY'+quest.rewardsArray[i].args[1];
                            for(let i = 0; i < quest.rewardsArray[i].args[0]; i++){
                                rewStr += ' QUALITY'+quest.rewardsArray[i].args[1];
                            }
                            break;
                    }
                }
                rewordText.setText(rewStr);
            }


            firstUi.addUpdate(function(){
                /*
                if(KEEPER.user.quests.current.isComplite){
                    button.text.setText(ASSETS.getText('text104',LANGUAGE)); 
                    //doneText.visible = true;
                    timeText.visible = false;
                    currentQuestComlpiteIcon.visible = true;
                }else{
                    currentQuestComlpiteIcon.visible = false;
                    if(KEEPER.user.quests.canChange){
                        timeText.visible = false;
                        button.button.tint = 0xFFFFFF;
                        button.text.tint = 0xFFFFFF;
                        button.button.input.enabled = true;
                    }else{
                        timeText.visible = true;
                        if(KEEPER.timers.leftChangeQuestTime)
                            timeText.text = KEEPER.timers.leftChangeQuestTime;
                        button.button.tint = 0x696969;
                        button.text.tint = 0x696969;
                        button.button.input.enabled = false;
                    }
                    button.text.setText(ASSETS.getText('text105',LANGUAGE)); 
                    //doneText.visible = false;
                    if(!usable){
                        timeText.visible = false;
                        button.button.visible = false;
                        button.text.visible = false;
                    }
                }
                */
                switch(KEEPER.user.quests.current.status){
                    case 'inProgress':
                        doneText.text = ASSETS.getText('text108',LANGUAGE);
                        doneText.tint = 0xFFD700;
                        button.button.visible = false;
                        button.text.visible = false;
                        currentQuestComlpiteIcon.visible = false;
                        
                        break;
                    case 'complite':
                        button.button.visible = true;
                        button.text.visible = true;
                        doneText.text = ASSETS.getText('text86',LANGUAGE);
                        doneText.tint = 0x8CB302;
                        button.text.setText(ASSETS.getText('text106',LANGUAGE)); 
                        currentQuestComlpiteIcon.visible = true;
                        currentQuestComlpiteIcon.frame = 0;
                        break;
                    case 'fail':
                        button.button.visible = true;
                        button.text.visible = true;
                        doneText.text = ASSETS.getText('text107',LANGUAGE);
                        doneText.tint = 0xBF0E0E;
                        button.text.setText(ASSETS.getText('text109',LANGUAGE)); 
                        currentQuestComlpiteIcon.visible = true;
                        currentQuestComlpiteIcon.frame = 1;
                        break;
                }
                attemptsText.text = ASSETS.getText('text110',LANGUAGE)+': '+KEEPER.user.quests.current.attempts.current+'/'+KEEPER.user.quests.current.attempts.max;

            });
            firstUi.addTween(['texts','images'],{ alpha: 1 },500);
            return firstUi; 
        }
        
       
        let lastQuestId = KEEPER.user.quests.current.id;
        mainUI.addUpdate(function(){
            if(lastQuestId !== KEEPER.user.quests.current.id){
                let quest = ATLAS.getQuestById(KEEPER.user.quests.current.id);
                lastQuestId = KEEPER.user.quests.current.id;
                window.delete();
                window = createQuestWindow();
                //redrawQuestInfo(quest);
            }
            
            //if( (KEEPER.user.quests.current.status == 'complite') || (KEEPER.user.quests.current.status == 'fail') || (KEEPER.user.quests.current.status == 'empty') ){
            if( (KEEPER.user.quests.current.status == 'complite') || (KEEPER.user.quests.current.status == 'fail') ){
                compliteQuest.visible = true;
                compliteQuest.animations.play('blink', 10, true);
            }else{
                compliteQuest.visible = false;
                compliteQuest.animations.stop();
            }
        });
    }
    createConfigWindow(mainUI){
        var that = this;
       
        let windowName = 'settings';
        ///Если это окно уже открыто не  создаем его
        if(that.isWindowOpen(windowName))
            return false;
        //Ставим флаг что окно открыто
        that.openWindow(windowName);
        function onClose(){
            that.closeWindow(windowName);
            firstUi.delete();
        }
        
        let firstUi = that.GUI.addUI(that.game.width/2 - 500,that.game.height/2 - 300,1000,600,null,null,10);
        firstUi.addFullWindowRect(0,0,0,that.game.width,that.game.height,true,0x000000,0.5,function(){
            onClose();
        });
        
        firstUi.addBackground(1,'ui_400_200',1,true);
        let ui = firstUi.addUI(1,true,firstUi.width/2 - 200,firstUi.height/2 - 100,400,200,15);
        ui.addButton(1,true,ui.width -25,25,32,32,'button_close',function(){
            onClose();
        },'onclick','onover',BUTTONVALUE,1);
        let uiName = ui.addBitMapText(1,true,ui.width*0.5,-30,ASSETS.getText('text51',LANGUAGE),'font_1',30,1,false);
        uiName.tint = 0xFFDAB9;
        
        
        let sound = ui.addImage(1,true,ui.width*0.8,ui.height*0.5,32,32,'sound_mute',1,true);
        sound.events.onInputDown.add(function(){
            game.sound.mute = !game.sound.mute;
            if(game.sound.mute){
                SOUND_MUTE = "YES";
                SOUND_MUTE = CH.setCookie('SoundMute',SOUND_MUTE); 
            }else{
                SOUND_MUTE = "NO";
                SOUND_MUTE = CH.setCookie('SoundMute',SOUND_MUTE); 
            }
            
        }, that);
        sound.input.useHandCursor = true;
     
        let languageChangeText = ui.addBitMapText(1,true,ui.width*0.2,ui.height*0.3,ASSETS.getText('text52',LANGUAGE)+': ','font_1',15,1,false);
        this.addChangeLanguageUI(ui,ui.width*0.8,ui.height*0.3);
        ui.addUpdate(function(){
            if(game.sound.mute){
                sound.frame = 1;
            }else{
                sound.frame = 0;
            }
            
        });
        
    }
    addChangeLanguageUI(mainUI,x,y){
        let flags = mainUI.addImage(1,true,x,y,50,25,'flags',1,true);
        //let flags = mainUI.addImage(1,true,mainUI.width - 50,50,50,25,'flags',1,true);
        flags.events.onInputDown.add(function(){
            if(LANGUAGE == 'en'){
                CH.setCookie('language','ru'); 
                LANGUAGE = CH.getCookie('language');
                game.state.restart();
            }else if(LANGUAGE == 'ru'){
                CH.setCookie('language','en'); 
                LANGUAGE = CH.getCookie('language');
                game.state.restart();
            }
        },this);
        mainUI.addUpdate(function(){
            if(LANGUAGE == 'en'){
                flags.frame = 0; 
            }else if(LANGUAGE == 'ru'){
                flags.frame = 1;
            }
        })
    }
   
    addTitleForArtifacts(mainUI,overObject,getArtId){
        ///Относительные ли UI координаты
        let that = this;
        
        let responseTime = 500;
        let closeTime = 20000;
        let isOver = false;
        let isOut = true;
        let startOverTime = null;
        ////0 Создаем массив для текстов
        /////1 Разбиваем на части строку - получаем массив
        /////2 Проверяем каждое слово с искомым массивом слов, создаем текст каждого слова в нужном стиле
        let firstUi = null;
        function createTitle(){
            if(firstUi == null){
              
                
                let artId = getArtId();
                let art = ATLAS.getArtifactInfoById(artId);
                let name = KEEPER.getArtifactNameInfo(art.id);
                let string = KEEPER.getArtifactTextInfo(art.id);
                function onClose(){
     
                    firstUi.delete();
                }
                let height = 200;
                let width = 400;
                let coords = getCoordinats(height,width);
                firstUi = that.GUI.addUI(coords.x,coords.y,width,height,null,null,10);
                //firstUi.addBackgroundRect(0,true,true,0x000000,0xFFD700,1,1,1,false);
                //firstUi.addBackground(1,'ui_400_200_2',1,true);
                firstUi.addImage(1,true,firstUi.width*0.5,firstUi.height*0.5,600,400,'ui_400_200_2',0,false);
                
                
                firstUi.addFullWindowBackRect(0,0,0,that.game.width,that.game.height,true,0x000000,0);
                
                
                let ui = firstUi.addUI(1,true,firstUi.width/2 - 200,firstUi.height/2 - 100,400,200,15);
                
                let uiName = ui.addBitMapText(1,true,ui.width*0.5,20,name,'font_1',25,0,false);
                switch(art.quality){
                    case 1:
                        uiName.tint = 0xB0C4DE;
                        break;   
                    case 2:
                        uiName.tint = 0x228B22;
                        break;
                    case 3:
                        uiName.tint = 0x1E90FF;
                        break;
                    case 4:
                        uiName.tint = 0x8A2BE2;
                        break;
                    case 5:
                        uiName.tint = 0xDC143C;
                        break;
                    case 6:
                        uiName.tint = 0xFF8C00;
                        break;
                }
                let y; 
                ui.addLine(2,true,ui.width*0.5 - uiName.width/2,40,ui.width*0.5 + uiName.width/2,40,0xFFD700,1,0,false)
               if(art.additionally.length > 0){
                   y = ui.height*0.5;
               } else{
                    y = ui.height*0.6;
               }
               console.log(ASSETS.textStyles['artifacts_title']); ui.addUIWithBitmapTextAndImage(1,true,ui.width*0.5,y,ui.width*0.95,'center',string,ASSETS.wordStyles,ASSETS.textStyles['artifacts_title'],40,0,false);
                console.log(art.additionally)
                if(art.additionally.length > 0){
                     y = ui.height - (15 +art.additionally.length*15);
                    ui.addLine(2,true,50,y,ui.width-50,y,0xFFD700,1,0,false)
                    for(let i in art.additionally){
                        let add = art.additionally[i];
                        let addText = ui.addBitMapText(1,true,ui.width*0.5,y + 15 + i*14,ASSETS.getText('TEG_'+add,LANGUAGE),'font_1',14,0,false);
                        addText.tint = 0x808080;
                    }
                    
                }
                
               // that.addWidgetWithBitmapTextAndImage(null,that.game.input.mousePointer.x,that.game.input.mousePointer.y,width,align,string,wordTypes,style,50,0,false);
                //firstUi = that.addWidgetWithBitmapTextAndImage(null,that.game.input.mousePointer.x,that.game.input.mousePointer.y,width,align,string,wordTypes,style,50,0,false);
                //firstUi = that.addWidgetWithTextAndImage(null,that.game.input.mousePointer.x,that.game.input.mousePointer.y,width,align,string,wordTypes,style,25,0,false);
               // firstUi.addBackground(1,'test',1,false);
                //let uiAlign = getAlign();
                //move(uiAlign.rl,uiAlign.tb);
                //firstUi.addBackgroundRect(0,true,true,0x000000,0xFFD700,1,0,1,false)
                //firstUi.addBackgroundRoundedRect(0,true,true,0x000000,0xFFD700,1,0,0.5,2,false);
                firstUi.addTween(['texts','images'],{ alpha: 1 },500);
                //firstUi.addTween(['graphics'],{ alpha: 0.8 },500);
                firstUi.addTween(['graphics'],{ alpha: 0.2 },500);
                
                
                function getAlign(){
                    let rl = 'right';
                    let tb = 'top';
                    if( (that.game.input.mousePointer.x + 600) > that.game.width){
                        rl = 'left';
                    }
                    ///Сдесь нужно отталкиваться от верхней точки либо иры либо камеры
                    if((that.game.input.mousePointer.y - 400) < 0){
                        tb = 'bot';
                    }
                    return {rl:rl,tb:tb};
                }
                function move(rl,tb){
                    if(rl == 'right'){
                        if(tb == 'top'){
                            firstUi.move(that.game.input.mousePointer.x,that.game.input.mousePointer.y - firstUi.height);

                        }else if(tb == 'bot'){
                            firstUi.move(that.game.input.mousePointer.x,that.game.input.mousePointer.y);

                        }

                    }else if(rl == 'left'){

                        if(tb == 'top'){
                            firstUi.move(that.game.input.mousePointer.x - firstUi.width,that.game.input.mousePointer.y - firstUi.height);

                        }else if(tb == 'bot'){
                            firstUi.move(that.game.input.mousePointer.x - firstUi.width,that.game.input.mousePointer.y);

                        }
                    }
                };
                function getCoordinats(h,w){
                    let align = getAlign();
                 
                    let rl = align.rl;
                    let tb = align.tb;
                    let x,y;
                    if(rl == 'right'){
                        if(tb == 'top'){
                            x = that.game.input.mousePointer.x;
                            y = that.game.input.mousePointer.y - h;

                        }else if(tb == 'bot'){
                            x = that.game.input.mousePointer.x;
                            y = that.game.input.mousePointer.y;
                        }

                    }else if(rl == 'left'){

                        if(tb == 'top'){
                            x = that.game.input.mousePointer.x - w;
                            y = that.game.input.mousePointer.y - h;

                        }else if(tb == 'bot'){
                            x = that.game.input.mousePointer.x - w;
                            y = that.game.input.mousePointer.y;

                        }
                    }
                    return {x:x,y:y};
                }
                let lastCursorX = that.game.input.mousePointer.x;
                let lastCursorY = that.game.input.mousePointer.y;
                firstUi.addUpdate(function(){
                    //Если положение курсора изменилось - двигаем тайтл
                    
                    if((lastCursorX !== that.game.input.mousePointer.x) || (lastCursorY != that.game.input.mousePointer.y)){
                        lastCursorX = that.game.input.mousePointer.x;
                        lastCursorY = that.game.input.mousePointer.y;
                        //uiAlign = getAlign();
                        //move(uiAlign.rl,uiAlign.tb);
                        deleteTitle();
                        startOverTime = new Date();
                        //createTitle();
                    }
                    
                })
                
            }
        }
        function deleteTitle(){
            if(firstUi !== null){
                
                firstUi.delete();
                firstUi = null;
            }
        }
        function ifLeftTime(time){
            if( (new Date() - startOverTime) > time)
                return true;
            else return false
        }
        
        if(overObject.input.enabled == true){
            overObject.events.onInputOver.add(function(){
                isOver = true;
                startOverTime = new Date();
                isOut = false;
            },this);
            overObject.events.onInputOut.add(function(){
                isOver = false;
                startOverTime = null;
            },this);
            overObject.input.useHandCursor = true;
        }
        function isRealOver(){
            let x = overObject.x - overObject.width/2;
            let y = overObject.y - overObject.height/2;
            if( ( (that.game.input.mousePointer.x > x) && (that.game.input.mousePointer.x < (x+overObject.width)) ) && ((that.game.input.mousePointer.y > y) && (that.game.input.mousePointer.y < (y+overObject.height)) ) )
                return true;
            return false;

        }
        mainUI.onUpdate.push(function(){
           if(overObject.input.isDragged){
                deleteTitle();
                isOver = false;
                startOverTime = null;
            }
            
            if(isOver){
                
                ///Если навели и время ответа прошло
                if( ifLeftTime(responseTime) ){
                    createTitle();
                }
                //Если прошло слишком много времени удаляем ui
                if( ifLeftTime(closeTime) ){
                    deleteTitle();
                    isOver = false;
                    startOverTime = null;
                }
                if(!isRealOver()){
                    deleteTitle();
                    isOver = false;
                    startOverTime = null;
                     // isOver = false;
                }
            }else if(!isOut){
                deleteTitle();
                isOut = true;
            }
            
             
            
        });
        return firstUi;
    }
    openWindow(name){
        this.windowsIsOpen[name] = true;
    }
    closeWindow(name){
        this.windowsIsOpen[name] = false;
    }
    isWindowOpen(name){
        if(this.windowsIsOpen[name]){
            if(this.windowsIsOpen[name] = true)
                return true;
        }
        return false;
    }
    randomInteger(min, max) {
        var rand = min - 0.5 + Math.random() * (max - min + 1)
        rand = Math.round(rand);
        return rand;
    }
}